diff --git a/contrib/pg_upgrade/check.c b/contrib/pg_upgrade/check.c
new file mode 100644
index 8594d26..891eb9a
*** a/contrib/pg_upgrade/check.c
--- b/contrib/pg_upgrade/check.c
*************** check_for_reg_data_type_usage(ClusterInf
*** 644,649 ****
--- 644,654 ----
  		DbInfo	   *active_db = &cluster->dbarr.dbs[dbnum];
  		PGconn	   *conn = connectToServer(cluster, active_db->db_name);
  
+ 		/*
+ 		 *	While several relkinds don't store any data, e.g. views, they
+ 		 *	can be used to define data types of other columns, so we
+ 		 *	check all relkinds.
+ 		 */
  		res = executeQueryOrDie(conn,
  								"SELECT n.nspname, c.relname, a.attname "
  								"FROM	pg_catalog.pg_class c, "
